Subject: Re: [PATCH] powerpc: update ibm,client-architecture

From: Joel Schopp <[email-masked]>
Date: Mon, 21 Dec 2009 16:14:54 -0600

>> OK.
>>     
>>>> +	W(NR_CPUS/4),			/* max cores supported */
>>>>         
>
> FYI reading the PAPR, this comment should technically be "max 'cpu'
> nodes presented".
>   
I applied a disambiguation filter to the comment since cpus can mean a 
lot of things these days ( ie hardware threads, cores, chips) , but a 
core is a core.

>> 4 is the new 2.  
>>     
>
> I'd still be asking what 2 is.  It's needs a #define to make clearer
> what you are doing.
>
>   
I'll add a #define
>> Since you don't know the actual threads per core at 
>> this point in boot you have to be conservative and go with the maximum 
>> number of any processor.  See page 4 of these charts:
>> http://www.power.org/events/powercon09/taiwan09/IBM_Overview_POWER7.pdf
>>     
>
> I don't think hard wiring 4 in here is right. If we are booting a
> machine with SMT2, we will put only half the number of cores that we can
> handle in this field.  This is going to break a lot of machines where
> people have compiled with NR_CPUS = thread number.
>
> I think you just want to put NR_CPUS here.  
>
>   
It's a bad interface.  No matter what you choose there will be a 
downside.  1) If you choose NR_CPUS, the best case of how many you could 
boot without SMT, then when you boot with SMT2 or SMT4 you can get 
assigned more cpus than you can boot.  2) If you choose NR_CPUS/4, the 
worst case of how many you could boot, and you get a large machine with 
SMT2 or SMT1 you might have said you support less cpus than you actually 
do and thus not boot all the cpus.  So no matter what you choose you 
could be not booting cpus in some theoretical scenario.